using System;
using System.ComponentModel;
using System.ServiceProcess;
using System.Configuration.Install;

namespace DPAPIService
{
	/// <summary>
	/// Summary description for DPAPIServiceInstaller.
	/// </summary>
	[RunInstaller(true)]
	public class DPAPIServiceInstaller : Installer
	{
		private ServiceInstaller dpApiInstaller;
		private ServiceProcessInstaller dpApiProcessInstaller;

		public DPAPIServiceInstaller()
		{
			dpApiInstaller = new ServiceInstaller();
			dpApiInstaller.StartType = System.ServiceProcess.ServiceStartMode.Manual;
			dpApiInstaller.ServiceName = "DPAPIService";
			dpApiInstaller.DisplayName = "DPAPI Service";
			Installers.Add (dpApiInstaller); 
			dpApiProcessInstaller = new ServiceProcessInstaller();
			dpApiProcessInstaller.Account = ServiceAccount.User;
			Installers.Add (dpApiProcessInstaller);
		}
	}
}
